#DEFINE WIN32_LEAN_AND_MEAN
#DEFINE LINKFILES
#include <windows.h>
#include <commctrl.h>
#include <commdlg.h> ;include this or this wil fail -> mov d[ofn.Flags],OFN_LONGNAMES + OFN_EXPLORER + OFN_HIDEREADONLY 

CONST SECTION
IDM_OPEN	equ 1
IDM_SAVE 	equ 2
IDM_EXIT 	equ 3
FirstMenu	equ 1001
MAXSIZE  	equ 255
MEMSIZE		equ 65535
EditID 		equ 1001	


DATA SECTION
	ofn					OPENFILENAME  
	ALIGN 4
	ClassName			DB 	"MainWinClass",0
	AppName				DB 	"memmanio",0
	EditClass			db	"edit",0
	MenuName			db	"FirstMenu",0
	FilterString		db	"All Files",0,"*.*",0
						db 	"Text Files",0,"*.txt",0,0
	TestText			db 	"Testing Eax Register for a NULL",0
	TestCap				db	"TESTER",0					
	buffer				db	MAXSIZE dup ?
	hWndEdit			dd 	?
	hFile				dd	?
	hMemory				dd	?
	pMemory				dd	?
	SizeReadWrite		dd	?
	hInstance			HINSTANCE  
	CommandLine			DD 	?

CODE SECTION

Start:

	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke GetCommandLine
	mov [CommandLine],eax
	invoke InitCommonControls
	invoke WinMain,[hInstance],NULL,[CommandLine],SW_SHOWNORMAL
	invoke ExitProcess,eax

WinMain FRAME hInst,hPrevInst,CmdLine,CmdShow
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:D

	mov D[wc.cbSize],SIZEOF WNDCLASSEX
	mov D[wc.style], CS_HREDRAW + CS_VREDRAW
	mov [wc.lpfnWndProc], OFFSET WndProc
	mov D[wc.cbClsExtra],NULL
	mov D[wc.cbWndExtra],NULL
	push [hInstance]
	pop [wc.hInstance]
	mov D[wc.hbrBackground],COLOR_WINDOW+1
	mov D[wc.lpszMenuName],OFFSET MenuName
	mov [wc.lpszClassName],OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov [wc.hIcon],eax
	mov [wc.hIconSm],eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov [wc.hCursor],eax
	
	invoke RegisterClassEx,addr wc
	invoke CreateWindowEx,\							; 	creat windows API
				WS_EX_CLIENTEDGE,\					; 	DWORD dwExStyle (The extended window style of the window being created)
				ADDR ClassName,\					; 	LPCTSTR lpClassName 
				ADDR AppName,\						; 	LPCTSTR lpWindowName
				WS_OVERLAPPEDWINDOW,\				;	DWORD dwStyle	
				CW_USEDEFAULT,\						;	int x (The initial horizontal position of the window)
				CW_USEDEFAULT,\						;	int y (The initial vertical position of the window)
				500,\								;	int nWidth
				500,\								;	int nHeight
				NULL,\								;	HWND hWndParent
				NULL,\								;	HMENU hMenu
				[hInst],\							;	HINSTANCE hInstance
				NULL								;	LPVOID lpParam (Pointer to a value to be passed to the window through the CREATESTRUCT structure)


	mov [hwnd],eax

	invoke ShowWindow, [hwnd],[CmdShow]
	invoke UpdateWindow, [hwnd]

	.messloop
		invoke GetMessage, ADDR msg,0,0,0
		or eax,eax
		JZ >.quit
			invoke TranslateMessage, ADDR msg
			invoke DispatchMessage,  ADDR msg
	JMP .messloop
	.quit

	mov eax,[msg.wParam]
	ret
ENDF

WndProc FRAME hWnd, uMsg, wParam, lParam
	uses edi,esi,ebx
	mov eax,[uMsg]
	cmp eax,WM_CREATE
	jne >.WMSIZE
	int 3											; 4 debugging remove before final
	invoke CreateWindowEx,\							; 	creat windows API
				NULL,\								; 	DWORD dwExStyle (The extended window style of the window being created)
				ADDR EditClass,\					; 	LPCTSTR lpClassName 
				NULL,\								; 	LPCTSTR lpWindowName
				WS_VISIBLE + WS_CHILD + ES_LEFT	+ \
				ES_MULTILINE + ES_AUTOHSCROLL + \
				ES_AUTOVSCROLL,\					;	DWORD dwStyle	
				0,\									;	int x (The initial horizontal position of the window)
				0,\									;	int y (The initial vertical position of the window)
				0,\									;	int nWidth
				0,\									;	int nHeight
				[hWnd],\							;	HWND hWndParent
				[EditID],\							;	HMENU hMenu
				[hInstance],\						;	HINSTANCE hInstance
				NULL								;	LPVOID lpParam (Pointer to a value to be passed to the window through the CREATESTRUCT structure)
				
			
	mov	[hWndEdit],eax								;save Edit handle
	
	invoke SetFocus,[hWndEdit]
; 	------------------------------------------------
;	Init  members of OPENFILENAME structure
;	------------------------------------------------
	mov	d[ofn.lStructSize],SIZEOF ofn
	push	[hWnd]
	pop	[ofn.hwndOwner]
	mov	[ofn.lpstrFilter],ADDR FilterString
	mov	[ofn.lpstrFile], ADDR buffer
	mov	d[ofn.nMaxFile],MAXSIZE
				
	jmp >>.EXIT

.WMSIZE
	cmp	eax,WM_SIZE
	jne	>.WMCOMMAND
	mov	eax,[lParam]
	mov	edx,eax
	shr	edx,16
	and	eax,0FFFFh
	invoke	MoveWindow,[hWndEdit],0,0,eax,edx,TRUE
	jmp	>>.EXIT
	
	
.WMCOMMAND
	cmp eax,WM_COMMAND
	jne >>.WMCLOSE
	mov	eax,[wParam]
	cmp d[lParam],0
	jne >>.CNTN
	cmp	ax,IDM_OPEN
	jne	>>.CHECK_NEXT
		mov	d[ofn.Flags],OFN_FILEMUSTEXIST + OFN_PATHMUSTEXIST +\
						OFN_LONGNAMES + OFN_EXPLORER+OFN_HIDEREADONLY
		invoke	GetOpenFileName,ADDR ofn
			cmp eax, TRUE
			jne >>.NOTTRUE 
				invoke CreateFile,\
						ADDR buffer,\
						GENERIC_READ + GENERIC_WRITE,\
						FILE_SHARE_READ + FILE_SHARE_WRITE,\
						NULL,\
						OPEN_EXISTING,\
						FILE_ATTRIBUTE_ARCHIVE,\
						NULL
				mov	[hFile],eax
				invoke GlobalAlloc,GMEM_MOVEABLE + GMEM_ZEROINIT,MEMSIZE
				mov	[hMemory],eax
				invoke GlobalLock,eax
				mov	[pMemory],eax
				invoke ReadFile,[hFile],[pMemory],MEMSIZE-1,ADDR SizeReadWrite,NULL
				Invoke	SendMessage,[hWndEdit],WM_SETTEXT,NULL,[pMemory]
				invoke	CloseHandle,[hFile]
				invoke	GlobalUnlock,[pMemory]
				invoke	GlobalFree,[hMemory]
			jmp	>>.CNTN

.CHECK_NEXT		
	cmp ax,IDM_SAVE
	jne	>>.CNTN
		mov d[ofn.Flags],OFN_LONGNAMES + OFN_EXPLORER + OFN_HIDEREADONLY 
        invoke GetSaveFileName, ADDR ofn
        cmp eax,TRUE
        jne >>.NOTTRUE
        	invoke 	CreateFile,ADDR buffer,\
                              GENERIC_READ + GENERIC_WRITE,\
                              FILE_SHARE_READ + FILE_SHARE_WRITE,\
                              NULL,CREATE_NEW,FILE_ATTRIBUTE_ARCHIVE,\
                              NULL
            mov [hFile],eax
            invoke GlobalAlloc,GMEM_MOVEABLE + GMEM_ZEROINIT,MEMSIZE
            mov  [hMemory],eax
            invoke GlobalLock,[hMemory]
            mov  [pMemory],eax
            invoke SendMessage,[hWndEdit],WM_GETTEXT,MEMSIZE-1,[pMemory]
            invoke WriteFile,[hFile],[pMemory],eax,ADDR SizeReadWrite,NULL
            invoke CloseHandle,[hFile]
            invoke GlobalUnlock,[pMemory]
            invoke GlobalFree,[hMemory]
            jmp	>.CNTN
.NOTTRUE            
            invoke	SetFocus,[hWndEdit]
.CNTN
	jmp >>.EXIT

.WMCLOSE
	cmp eax,WM_CLOSE
	jne >.WMDESTROY
	invoke DestroyWindow,[hWnd]
	jmp >.EXIT

.WMDESTROY
	cmp eax,WM_DESTROY
	jne >.DEFPROC
	invoke PostQuitMessage,NULL
	jmp >>.DEFPROC

.DEFPROC
		invoke DefWindowProc,\
					[hWnd],\
					[uMsg],\
					[wParam],\
					[lParam]		
		ret

.EXIT
	xor eax,eax
	ret
ENDF

